#import <objc/Object.h>
#import <objc/List.h>
#import "DebugProtos.h"
#import "Value.h"

@class Block;

@protocol BlockGetter
-(List *)blockValuesFor: (void *)data;
-(char *)nameForPC: (unsigned)pc;
-(int)hasSymbolsForPC: (unsigned)pc;
-(Block *)makeBlock: (unsigned)pc;
-(char *)filenameForPC: (unsigned)pc line: (unsigned *)line;
@end

@interface Block : Object
<BaseValueGetting>
{
    id superBlock;
    unsigned start;
    unsigned end;
    List *locals;
    void *data;
}

+(void)setBlockGetter: (id <BlockGetter>)theGetter;
-(List *)locals;
-(int)numLocals;
-(void)setStart: (unsigned)theStart;
-(unsigned)start;
-(void)setEnd: (unsigned)theEnd;
-(unsigned)theEnd;
-(void)setData: (void *)theData;
-(void)setSuperBlock: (Block *)theSuperBlock;
-(Block *)superBlock;
-(char *)functionName;

@end

@interface Frame : Object <Frame>
{
@public
    Block *block;
    unsigned frame;
    unsigned pc;
    int frameNumber;
}
-(void)setFrame: (unsigned)theFrame;
-(void)setPC: (unsigned)thePC;
-(void)setFrameNumber: (int)fn;
@end

@interface BlockList : List

-(Block *)blockForPC: (unsigned)pc;

@end