#import <objc/Object.h>
#import <objc/List.h>
#import <objc/maptable.h>
#import <mach/mach.h>
#import <remote/NXConnection.h>
#import <machkit/NXPort.h>
#import <appkit/Speaker.h>
#import <mach/cthreads.h>

#import "Value.h"
#import "Type.h"
#import "Block.h"

@protocol GdbInternal
-(void)connectToSpeaker: (Speaker *)theSpeaker;
-(void)disconnect: (BOOL)tellClient;
-(void)openFile: (char *)fileName fromTrueLine: (int)firstLine to: (int)lastLine;
-(void)openFile: (char *)fileName atTrueLine: (int)line;
-(void)programStopped;
-(void)frameChanged;
-(oneway void)programIsRunning;
-(void)programIsDead;
@end

@interface GdbController : Object
<GdbController, GdbInternal, DataGetter, ErrorDelegate, TypeGetter, BlockGetter, Interrupt, NXSenderIsInvalid>
{
    NXConnection *connection;
    NXConnection *interruptConnection;
    thread_t mainThread;
    NXMapTable *types;
    NXMapTable *values;
    NXMapTable *blocks;
    NXMapTable *demangledNames;
    Frame *frames;
    int numFrames;
    int numFramesAlloced;
    id <GdbUser>client;
    mutex_t clientLock;
    condition_t clientCond;
    BOOL lastToldAboutRunning;
    BOOL symbolsOnly;
    BOOL newStyle;
    int maxFrames;
    int *selFrame;
}

-(Value *)makeValue: (struct symbol *)sym;
-(void)allocFrames: (int)nFrames;
@end