#include <devkit/TokenType.h>

#ifdef __BIG_ENDIAN__
struct _Token_w0 {
  TokenType tokenType:8;
  unsigned posInLine:8; // or high bits for Tok_line, Tok_posInLine
  unsigned line:16;
};
#endif /* __BIG_ENDIAN__ */
#ifdef __LITTLE_ENDIAN__
struct _Token_w0 {
  unsigned line:16;
  unsigned posInLine:8; // or high bits for Tok_line, Tok_posInLine
  TokenType tokenType:8;
};
#endif  

class Token {
 public:
  Token(unsigned l, unsigned p, TokenType tt, char *s);
 private:
  struct _Token_w0 w0;
  union {
    char *string;
    int offset;
  } w1;
};

struct TokenStruct {
  struct _Token_w0 w0;
  union {
    char *string;
    int offset;
  } w1;
};

Token::Token(unsigned l, unsigned p, TokenType tt, char *s)
{
    w0.line = l;
    w0.posInLine = p;
    w0.tokenType = tt;
    w1.string = s;
    return this;
}

int main()
{
    Token *token = new Token(1, 2, Tok_fileLine, "abc");
#ifdef __BIG_ENDIAN__
    struct TokenStruct tokenStruct = {{Tok_fileLine, 2, 1}}; 
#else
    struct TokenStruct tokenStruct = {{1, 2, Tok_fileLine}, "abc"};
#endif
    tokenStruct.w1.string = "abc";
    return 1;
}
